
Hooks:PostHook(PlayerManager,"_internal_load","mat_internalload_setup_gaslist",function(self)
	self.mat_gaspools = {}
end)

function PlayerManager:add_mat_gaspool(pool)
	if not (pool and type(pool) == "table") then
		return
	end
	table.insert(self.mat_gaspools,pool)
end

function PlayerManager:remove_mat_gaspool(id)
	self.mat_gaspools[id] = nil
end

Hooks:PostHook(PlayerManager,"update","mat_check_poison_update_playermanager",function(self,t,dt)
	local player = self:player_unit()
	if not player then
		return
	end
	if not self.mat_gaspools then
		return
	end
	for id,pool in pairs(self.mat_gaspools) do 
		if pool.expire_t < t then
			World:effect_manager():fade_kill(pool.smoke_effect)
			World:effect_manager():fade_kill(pool.smoke_explosion)
			--todo check remove sound source 
			self:remove_mat_gaspool(id)
		elseif pool.dmg_t + pool.dmg_interval < t then  --randomness to spice things up a bit and offset synced stun animations
			pool.dmg_t = t + math.random(0.4)
			
			local pos = pool.position
			local dmg_cop = pool.damage_dot_cop
			local dmg_ply = pool.damage_dot_player
			local radius = pool.dmg_radius
--			local interval = pool.dmg_interval
--			local sound = pool.sound_source
--			local expl = pool.smoke_explosion
--			local effect = pool.smoke_effect
			local owner = pool.owner
--			local entry = pool.entry
			local weapon = pool.weapon
			
			local enemies = World:find_units_quick("sphere",pos,radius,12,21)
			local radius_sq = radius * radius
			local in_range = player and mvector3.distance_sq(player:position(),pos) <= radius_sq
			
			if player and in_range then 
				player:character_damage():damage_killzone({
					variant = "killzone",
					damage = dmg_ply,
					col_ray = {ray = math.UP}
				})
			end
			
			if Network:is_server() then --!
				for _,unit in pairs(enemies) do 
					if unit:character_damage() and not managers.enemy:is_civilian(unit) then
						unit:character_damage():damage_dot({
							attacker_unit = owner and managers.criminals:character_unit_by_peer_id(owner) or player,
							pos = pos,
							hurt_animation = pool.hurt_animation or false,
							damage = dmg_cop,
							variant = "poison",
							weapon_id = weapon,
							col_ray = {}
						})
					end
				end
			end
			
		end
	end
end)
